; Extractor demo V2.0 by Vortex

.386
.model flat, stdcall
option casemap :none

EXTERN pData:BYTE

JCALG1_Decompress_Fast						PROTO :DWORD,:DWORD
JCALG1_GetUncompressedSizeOfCompressedBlock	PROTO :DWORD

include		\GeneSys\include\windows.inc 
include		\GeneSys\include\kernel32.inc 

includelib	\GeneSys\lib\kernel32.lib

FILE_SIZE	equ	3072

.data
szFilename	db 'DialogBox.exe',0

.data?
hFile		dd					?
size1		dd					?
nSize		dd 					?
pMem		dd 					?
startinfo   STARTUPINFO			<?>
processinfo PROCESS_INFORMATION <?>

.code

start:

	invoke	JCALG1_GetUncompressedSizeOfCompressedBlock,ADDR pData
	mov		nSize,eax								;	Get the size of the original
													;	data block
	invoke	VirtualAlloc,0,eax,MEM_COMMIT,PAGE_READWRITE
	mov		pMem,eax
	invoke	JCALG1_Decompress_Fast,ADDR pData,eax	;	Decompress the data block
													;	to memory 

	invoke	CreateFile,ADDR szFilename,GENERIC_WRITE,\
			0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_ARCHIVE,0
	mov		hFile,eax
	invoke	WriteFile,eax,pMem,FILE_SIZE,ADDR size1,0
	invoke	CloseHandle,hFile
	invoke	VirtualFree,pMem,0,MEM_RELEASE

	invoke	CreateProcess,ADDR szFilename,0,0,0,0,0,0,0,\
			ADDR startinfo,ADDR processinfo

	invoke	ExitProcess,0

END start